Index: include/channel_mode.h
===================================================================
RCS file: /cvsroot/ircd-ratbox/include/Attic/channel_mode.h,v
retrieving revision 7.22.2.3
diff -u -r7.22.2.3 channel_mode.h
--- a/include/channel_mode.h	7 Nov 2003 00:00:37 -0000	7.22.2.3
+++ b/include/channel_mode.h	25 Feb 2004 02:14:47 -0000
@@ -86,7 +86,7 @@
 #define MODE_EXCEPTION  0x0800
 #define MODE_INVEX	0x2000
 #define MODE_HIDEOPS    0x4000
-
+#define MODE_NOCOLOR	0x8000
 /*
  * mode flags which take another parameter (With PARAmeterS)
  */
Index: modules/core/m_message.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/modules/core/m_message.c,v
retrieving revision 1.131.2.5
diff -u -r1.131.2.5 m_message.c
--- a/modules/core/m_message.c	8 Jan 2004 01:20:17 -0000	1.131.2.5
+++ b/modules/core/m_message.c	25 Feb 2004 02:14:47 -0000
@@ -53,6 +53,29 @@
 	int flags;
 };
 
+/* check to see if the message has any color chars in it. */
+static int msg_has_colors(const char *msg)
+{
+ 
+    const char *c;
+    if (msg==NULL) return 0;
+    c=msg;
+    while(*c)
+    {
+        if(*c == '\003' || *c == '\033' || *c == '\026' || *c == '\037')
+            break;
+        else
+            c++;
+    }
+
+    if(*c)
+        return 1;
+
+    return 0;
+}
+ 
+
+
 static int build_target_list(int p_or_n, const char *command,
 			     struct Client *client_p,
 			     struct Client *source_p, char *nicks_channels, const char *text);
@@ -439,7 +462,7 @@
 	}
 
 	/* chanops and voiced can flood their own channel with impunity */
-	if((result = can_send(chptr, source_p, NULL)))
+	if((result = can_send(chptr, source_p, NULL)) && !(chptr->mode.mode & MODE_NOCOLOR && msg_has_colors(text)))
 	{
 		if(result == CAN_SEND_OPV ||
 		   !flood_attack_channel(p_or_n, source_p, chptr, chptr->chname))
Index: src/channel_mode.c
===================================================================
RCS file: /cvsroot/ircd-ratbox/src/Attic/channel_mode.c,v
retrieving revision 7.107.2.7
diff -u -r7.107.2.7 channel_mode.c
--- a/src/channel_mode.c	7 Nov 2003 00:00:44 -0000	7.107.2.7
+++ b/src/channel_mode.c	25 Feb 2004 02:14:47 -0000
@@ -332,7 +332,9 @@
 		*mbuf++ = 'i';
 	if(chptr->mode.mode & MODE_NOPRIVMSGS)
 		*mbuf++ = 'n';
-
+	if(chptr->mode.mode & MODE_NOCOLOR)
+		*mbuf++ = 'c';
+		
 	if(chptr->mode.limit)
 	{
 		*mbuf++ = 'l';
@@ -1309,7 +1311,7 @@
   {chm_nosuch, NULL},
   {chm_nosuch, NULL},				  /* a */
   {chm_ban, NULL},                                /* b */
-  {chm_nosuch, NULL},                             /* c */
+  {chm_simple, (void *) MODE_NOCOLOR},            /* c */
   {chm_nosuch, NULL},                             /* d */
   {chm_except, NULL},                             /* e */
   {chm_nosuch, NULL},                             /* f */
